<template>
  <q-layout view="hHh lpR fFf" class="bg-grey-1">
    <q-header elevated class="bg-deep-purple-6 text-amber-6" height-hint="64">
      <q-toolbar class="GNL__toolbar">
        <q-btn
          flat
          dense
          round
          @click="leftDrawerOpen = !leftDrawerOpen"
          aria-label="Menu"
          icon="menu"
          class="q-mr-sm"
        />
        <q-toolbar-title v-if="$q.screen.gt.xs" shrink class="row items-center no-wrap">
          <span class="q-ml-sm text-white">Smart
          <span class="text-amber-6">Bet</span>
          </span>
        </q-toolbar-title>
        <q-space/>
        <BroadcastMessage :messages="messages.flatMap(x=> x.message)"/>
        <q-space/>
        <div class="q-gutter-sm row  no-wrap text-white">
          <q-btn round flat icon="payment">
            <q-chip class="q-px-md" flat :label="credit"/>
            <q-tooltip>Credit</q-tooltip>
          </q-btn>
          <q-btn-dropdown round flat icon="person">
            <template v-slot:label>
              <q-chip class="q-px-md" flat :label="username"/>
              <q-tooltip>Account</q-tooltip>
            </template>
            <q-list>
              <q-item @click.prevent="onLogout" clickable v-close-popup>
                <q-item-section avatar>
                  <q-icon name="logout"/>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Logout</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-btn-dropdown>
        </div>
      </q-toolbar>
    </q-header>
    <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      content-class="bg-deep-purple-15"
      :width="300"
    >
      <q-scroll-area class="fit">
        <q-list class="text-white q-pt-sm">
          <q-item class="GNL__drawer-item" active-class="is-active" to="/v2/dashboard" v-ripple clickable>
            <q-item-section avatar>
              <q-icon name="grid_view"/>
            </q-item-section>
            <q-item-section>
              <q-item-label>Dashboard</q-item-label>
            </q-item-section>
            <q-item-section  side top>
              <q-badge label="v2" />
            </q-item-section>
          </q-item>
          <q-expansion-item active-class="is-active" expand-separator>
            <template v-slot:header>
              <q-item class="GNL__drawer-item q-px-none full-width" v-ripple clickable>
                <q-item-section avatar>
                  <q-icon name="person"/>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Account</q-item-label>
                </q-item-section>
              </q-item>
            </template>
            <q-list class="bg-white">
              <q-item class="GNL__drawer-item q-pl-lg" v-ripple clickable>
                <q-item-section avatar>
                  <q-icon name="manage_accounts"/>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Profile</q-item-label>
                </q-item-section>
              </q-item>
              <q-item class="GNL__drawer-item q-pl-lg" @click.prevent="changePasswordModal = true;" v-ripple clickable>
                <q-item-section avatar>
                  <q-icon name="password"/>
                </q-item-section>
                <q-item-section>
                  <q-item-label>Change Password</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-expansion-item>
          <OrganizeSideMenu :role="this.role"/>
          <ManagementSideMenu/>
          <ReportSideMenu :role="this.role"/>
          <SettingSideMenu v-if="this.role < 2"/>
          <div class="q-mt-md">
            <div class="flex flex-center q-gutter-xs">
              <a class="GNL__drawer-footer-link" href="javascript:void(0)" aria-label="Privacy">Privacy</a>
              <span> · </span>
              <a class="GNL__drawer-footer-link" href="javascript:void(0)" aria-label="Terms">Terms</a>
              <span> · </span>
              <a class="GNL__drawer-footer-link" href="javascript:void(0)" aria-label="About">About</a>
            </div>
          </div>
        </q-list>
      </q-scroll-area>
    </q-drawer>
    <q-page-container>
      <div class="q-pa-md ">
        <q-breadcrumbs gutter="xs" :key="`${$route.fullPath}_breadcrumbs`">
          <q-breadcrumbs-el label="Home" :to="{ path: '/v2'  }"/>
          <q-breadcrumbs-el :key="index"
                            v-for="(breadcrumb, index) in breadcrumbs"
                            :to="{ path: breadcrumb.path  }"
                            :label="breadcrumb.title"/>
        </q-breadcrumbs>
      </div>
      <router-view :key="$route.fullPath"/>
      <q-dialog v-model="changePasswordModal">
        <q-card class="q-pa-md" style="width: 400px; max-width: 80vw;">
          <q-form class="q-gutter-sm" label-width="120px" @submit.prevent="onChangePassword" autocomplete="off">
            <q-card-section>
              <div>
                <label>
                  รหัสผ่านใหม่
                  <q-input v-model="$v.changePasswordForm.new_password.$model" type="password"
                           :autocomplete="'off'"
                           :error="$v.changePasswordForm.retype_new_password.$error"
                           error-message="กรุณากรอกรหัสผ่านอย่างน้อย 8 ตัว"
                           outlined dense/>
                </label>
              </div>
              <div>
                <label>
                  ยืนยันรหัสผ่าน
                  <q-input v-model="$v.changePasswordForm.retype_new_password.$model" type="password"
                           :autocomplete="'off'"
                           :error="$v.changePasswordForm.retype_new_password.$error"
                           error-message="กรุณากรอกผ่านให้ตรงกัน"
                           outlined dense/>
                </label>
              </div>
            </q-card-section>
            <q-separator/>
            <q-card-actions align="right">
              <q-btn v-close-popup flat color="negative" label="ปิด"/>
              <q-btn push type="submit" color="primary" label="เปลี่ยนรหัสผ่าน"/>
            </q-card-actions>
          </q-form>
        </q-card>
      </q-dialog>
    </q-page-container>
  </q-layout>
</template>

<script>
import 'element-ui/lib/theme-chalk/index.css';
import {mapState, mapMutations, mapActions} from "vuex";
import ReportSideMenu from "../components/reportSideMenu"
import OrganizeSideMenu from "../components/organizeSideMenu"
import ManagementSideMenu from "../components/managementSideMenu"
import SettingSideMenu from "../components/settingSideMenu"
import BroadcastMessage from "../components/broadcastMessage"
import {required, minLength, sameAs} from 'vuelidate/lib/validators'

export default {
  name: 'GoogleNewsLayout',
  components: {OrganizeSideMenu, SettingSideMenu, ManagementSideMenu, BroadcastMessage, ReportSideMenu},
  data() {
    return {
      leftDrawerOpen: false,
      changePasswordModal: false,
      changePasswordForm: {
        new_password: "",
        retype_new_password: "",
      }
    }
  },
  validations: {
    changePasswordForm: {
      new_password: {
        required,
        minLength: minLength(8)
      },
      retype_new_password: {
        required,
        sameAsPassword: sameAs('new_password')
      },
    }
  },
  watch: {
    changePasswordModal(newValue, oldValue) {
      if (newValue) {
        this.changePasswordForm = {
          new_password: "",
          retype_new_password: ""
        }
      }
    }
  },
  computed: {
    ...mapState('auth', ['credit', 'username', 'role']),
    ...mapState('message', ['messages']),
    breadcrumbs() {
      return this.$route.meta.breadcrumbs;
    }
  },
  methods: {
    ...mapActions('auth', ['logout', 'changePassword']),
    ...mapActions('message', {
      load_message: 'load'
    }),
    ...mapMutations('auth', ['set_logout']),
    ...mapMutations('message', ['set_messages']),
    async onChangePassword(e) {
      this.$q.loading.show();
      this.$v.changePasswordForm.$touch();
      try {
        if (!this.$v.changePasswordForm.$invalid) {
          const response = await this.changePassword(this.changePasswordForm);

          this.changePasswordModal = false;
          this.$q.loading.hide();
          this.$dialog.alert("เปลี่ยนรหัสผ่านเสร็จสิ้น")
        }
      } catch (ex) {
        this.$q.loading.hide();
        this.$dialog.errorException(ex);
      }
    },
    async onLogout() {
      try {
        const response = await this.logout();
        if (response) {
          this.set_logout();
        }
        this.$router.push({path: '/v2/login'});
      } catch (e) {
        this.set_logout();
        this.$router.push({path: '/v2/login'});
      }
    }
  },
  async created() {
    this.routes = this.$route.matched.filter(x => x.meta.name).map(x => x.meta.name);
    const {data: {results: messages}} = await this.load_message();
    this.set_messages(messages);
  }
}
</script>
<style lang="scss">
.q-expansion-item__content {
  .GNL__drawer-item {
    .q-item__section--avatar {
      .q-icon {
        color: $dark !important;
      }
    }

    .q-item__label {
      color: $dark !important;
    }
  }
}

div.q-list {
  .q-expansion-item.q-expansion-item--expanded {
    background: $deep-purple-6 !important;
    border: 5px solid $amber-6;
    color: whitesmoke !important;
    border-radius: 10px;
  }
}

.GNL {
  &__toolbar {
    height: 48px;
  }

  &__toolbar-input {
    width: 55%;
  }

  &__drawer-item {
    line-height: 1;
    border-radius: 10px;

    .q-item__section--avatar {
      .q-icon {
        //color: #5f6368;
      }
    }

    .q-item__label {
      letter-spacing: .01785714em;
      font-size: .875rem;
      font-weight: 500;
      line-height: 1.25rem;
    }
  }

  &__drawer-footer-link {
    color: inherit;
    text-decoration: none;
    font-weight: 500;
    font-size: .75rem;

    &:hover {
      color: #000;
    }
  }
}

.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
